{
Copyright  Frdric MONTIN, 2007

dekibulle@free.fr
http://dekibulle.free.fr

**fr**

Ce logiciel est un programme informatique servant  lire des fichiers
audio sur ordinateur.

Ce fichier est une partie de dkibulle.

Dkibulle est un logiciel libre; soumis  une double licence. 
Vous pouvez le redistribuer ainsi que le modifier ds lors que vous respectez 
les termes *de l'une des deux licences*
- *soit* la licence GNU Lesser General Public License comme publie par la 
  Free Software Foundation, dans sa version 2 ou ultrieure; 
- *soit* la licence Cecill-C comme publie par Cecill,
  dans sa version 1 ou ultrieure.

**en**

This software is a computer program whose purpose is to listen audio
files on a computer.

This file is a part of Dkibulle.

Dkibulle is a free software; subjected to a double license.
You can redistribute it and/or modify since you respect the terms of either 
(at least one of the both license) :
- the GNU Lesser General Public License as published by the Free Software Foundation; 
  either version 2.1 of the License, or any later version. 
- the CeCILL-C as published by CeCILL; either version 1 of the License, or any later version.
}

unit DeKiBulleUtils;

interface

Uses  Windows, Classes, Graphics, Messages, StrUtils, CoolTrayIcon,
      SysUtils, IniFiles, Forms, Controls, ShellAPI, ID3v1, ID3v2, WMAFile, OGGVorbis, APETag,
      Unit1, Unit_Form_Options, Unit_Form_Tag, Unit_Form_Egaliseur, Unit_Form_InfoBulle, Bass, BassCD, Registry, InfoMPEG, HttpProt;

function  Split(S: string; d: Pchar): TStringList;
function  NomFichierSon(F: string): string;
function  ValideExt(const F: string): boolean;
function  IsURL(const F: string): boolean;
procedure MiseaJoursCouleurs(Totale : Boolean = True);
procedure Executer(const action : string);
function  GetGenreFromIndex(Index : integer): string;
function  GetIndexofGenre(const Genre : String): byte;
procedure SetEqualizer;
procedure SetVolume;
function  CheckVersion(const AffSiNon : Boolean = True): Boolean;
procedure GetCDDB(Lecteur: integer);
function  ExtraitEXTINF(const Texte : string): string;

const
  SGenre : array[0..148] of string = ('Blues','Classic Rock','Country','Dance','Disco','Funk','Grunge',
    'Hip-Hop','Jazz','Metal','New Age','Oldies','Other','Pop','R&B','Rap','Reggae','Rock','Techno',
    'Industrial','Alternative','Ska','Death Metal','Pranks','Soundtrack','Euro-Techno','Ambient','Trip-Hop',
    'Vocal','Jazz+Funk','Fusion','Trance','Classical','Instrumental','Acid','House','Game','Sound Clip',
    'Gospel','Noise','AlternRock','Bass','Soul','Punk','Space','Meditative','Instrumental Pop',
    'Instrumental Rock','Ethnic','Gothic','Darkwave','Techno-Industrial','Electronic','Pop-Folk','Eurodance',
    'Dream','Southern Rock','Comedy','Cult','Gangsta','Top 40','Christian Rap','Pop/Funk','Jungle',
    'Native American','Cabaret','New Wave','Psychadelic','Rave','Showtunes','Trailer','Lo-Fi','Tribal',
    'Acid Punk','Acid Jazz','Polka','Retro','Musical','Rock & Roll','Hard Rock','Folk','Folk-Rock',
    'National Folk','Swing','Fast Fusion','Bebob','Latin','Revival','Celtic','Bluegrass','Avantgarde',
    'Gothic Rock','Progressive Rock','Psychedelic Rock','Symphonic Rock','Slow Rock','Big Band','Chorus',
    'Easy Listening','Acoustic','Humour','Speech','Chanson','Opera','Chamber Music','Sonata','Symphony',
    'Booty Bass','Primus','Porn Groove','Satire','Slow Jam','Club','Tango','Samba','Folklore','Ballad',
    'Power Ballad','Rhythmic Soul','Freestyle','Duet','Punk Rock','Drum Solo','A capella','Euro-House',
    'Dance Hall','Goa','Drum & Bass','Club-House','Hardcore','Terror','Indie','BritPop','Negerpunk',
    'Polsk Punk','Beat','Christian Gangsta Rap','Heavy Metal','Black Metal','Crossover',
    'Contemporary Christian','Christian Rock','Merengue','Salsa','Thrash Metal','Anime','JPop','Synthpop','Unknow');

implementation

{------------------------------------------------------------------------}
{       fonction Split                                                   }
{------------------------------------------------------------------------}
function Split(S: string; d: Pchar): TStringList;
var
    Spliti: integer;
    Splitt: string;
begin
    Result := TStringList.Create;
    Splitt := '';
    for Spliti := 1 to Length(S) do begin  // une string a commence  1...
        if S[Spliti] = d then begin
            if Splitt <> '' then begin
                Result.Add(Splitt);
                Splitt := '';
            end;
        end else
            Splitt := Splitt + S[Spliti];
    end;
    if Splitt <> '' then
        Result.Add(Splitt);
end;

//============================================================================//
{             Renvoie le nom d'un fichier son  afficher                       }
//----------------------------------------------------------------------------//
function RemplaceTexteTag(const FormatNom, Duree, Artist, Album, TrackNb, TrackTitle, Rep1, Rep0, FileName, FileExt: String): String;
begin
    Result := AnsiReplaceText(' ' + FormatNom, '%length',     Duree);
    Result := AnsiReplaceText(Result,          '%artist',     Trim(Artist));
    Result := AnsiReplaceText(Result,          '%album',      Trim(Album));
    Result := AnsiReplaceText(Result,          '%tracknb',    TrackNb);
    Result := AnsiReplaceText(Result,          '%tracktitle', Trim(TrackTitle));
    Result := AnsiReplaceText(Result,          '%rep1',       Rep1);
    Result := AnsiReplaceText(Result,          '%rep0',       Rep0);
    Result := AnsiReplaceText(Result,          '%filename',   FileName);
    Result := AnsiReplaceText(Result,          '%fileext',    FileExt);
end;
function RemplaceTexteSansTag(const FormatNom, Rep1, Rep0, FileName, FileExt, Duree: String): String;
begin
    Result := AnsiReplaceText(' ' + FormatNom, '%rep1',     Rep1);
    Result := AnsiReplaceText(Result,          '%rep0',     Rep0);
    Result := AnsiReplaceText(Result,          '%filename', FileName);
    Result := AnsiReplaceText(Result,          '%fileext',  FileExt);
    Result := AnsiReplaceText(Result,          '%length',   Duree);
end;
function NomFichierSon(F: string): string;
const
    TimeAdj = 86400;
var
    MP3Tagv1 : TID3v1;
    MP3Tagv2 : TID3v2;
    WMATag   : TWMAfile;
    OGGTag   : TOggVorbis;
    APETag   : TAPETag;
    Ext, Rep1, Rep0, Fichier : String;
    n        : TstringList;
    Ch, i, j : Integer;
    D        : single;
    Duree, CDDBCDID    : String;
    LocalCDDBIni : TIniFile;
begin
    Application.ProcessMessages;

        { Est-ce que le fichier est une URL ? }
    if IsURL(F) then begin
        Result := ' ' + F;
        Exit;
    end;

        { Est-ce que le fichier existe ? }
    if not(FileExists(F)) then begin
        Result := ' No File... ' + ExtractFileName(F);
        Exit;
    end;

    Ext     := LowerCase(ExtractFileExt(F));
    Fichier := Copy(ExtractFileName(F), 1, Length(ExtractFileName(F)) - Length(Ext));
    n       := Split(F, '\');
    With n do begin
      Rep0 := Strings[Count - 2];
      if Count >= 3 then
          Rep1 := Strings[Count - 3]
      else
          Rep1 := '';
      Free;
    end;
    Duree := '';

        { Si le fichier est un cda (CD audio) }
    if AnsiContainsText('$.cda$', Ext) then begin
        If OptionLireCDDB then begin
            i := 0;     // Dtermine le No du lecteur
            while (i < 10) and (Char(BASS_CD_GetDriveLetter(i) + Ord('A')) <> F[1]) do
                i := i + 1;
            if i < 10 then begin
                        // Dtermine le CDID du lecteur
                CDDBCDID     := AnsiReplaceStr(BASS_CD_GetID(i, BASS_CDID_CDDB), ' ', '+');
                LocalCDDBIni := TIniFile.Create(ExtractFilePath(Application.Exename) + '\DeKiBulle.cddb');
                        // Cherche les infos sur la cddb locale
                with LocalCDDBIni do begin
                    if SectionExists(CDDBCDID) then begin
                        if ReadBool(CDDBCDID, 'MATCH', False) then begin
                            j := StrToInt(Copy(Fichier, 6, 2));    // No de Track
                            if ValueExists(CDDBCDID, Format('TITLE%d', [j])) then begin
                                Result := RemplaceTexteTag(FormatNomTag, ReadString(CDDBCDID, Format('LENGTH%d', [j]), ''), ReadString(CDDBCDID, 'ARTIST', ''), ReadString(CDDBCDID, 'ALBUM', ''), Format('%.2d', [j]), ReadString(CDDBCDID, Format('TITLE%d', [j]), ''), Rep1, Rep0, Fichier, Ext);
                                Free;
                                Exit;
                            end;
                        end;
                    end else begin
                        with Form1.TimerCDDB do
                            if Not(Enabled) then begin
                                Tag     := i;
                                Enabled := True; // Dans quelques secondes on va tenter de regarder les infos CDDB...
                            end;
                    end;
                    Free;
                end;
            end; // Fin 'if i < 10'
        end;
        Result := RemplaceTexteSansTag(FormatNomCDA, Rep1, Rep0, Fichier, Ext, Duree);
        Exit;
    end;

        { Dtermine la dure de la chanson si ncessaire }
    if AnsiContainsText(FormatNomTag, '%length') OR AnsiContainsText(FormatNomSansTag, '%length') then begin
        Ch := BASS_StreamCreateFile(FALSE, PChar(F), 0, 0, 0);
        if Ch <> 0 then begin
            D := BASS_ChannelBytes2Seconds(Ch, BASS_ChannelGetLength(Ch)) / TimeAdj;
            if D >= 1/24 then                             // Si la chanson dure plus d'une heure
                Duree := FormatDateTime('[hh:nn:ss]', D)
            else
                Duree := FormatDateTime('[nn:ss]', D);
        end;
        BASS_StreamFree(Ch);
    end;

        { Si le fichier est un mp3 ou mp2 on tente de regarder les TAG ID3 v2 }
    if AnsiContainsText('$.mp3$.mp2$', Ext) and OptionLireMetaTags then begin
            { Lecture TAG ID3 v2 }
        MP3Tagv2 := TID3v2.Create;
        With MP3Tagv2 do begin
            ReadFromFile(F);
            if (Exists) and (Trim(Title) <> '') then begin
                Result := RemplaceTexteTag(FormatNomTag, Duree, Artist, Album, Format('%.2d', [Track]), Title, Rep1, Rep0, Fichier, Ext);
                Free;
                Exit;
            end;
            Free;
        end;
    end;

        { Si le fichier est un mpc, wv, ofr, ofs, ape ou mac on tente de regarder les TAG APE }
    if AnsiContainsText('$.mpc$.wv$.ofr$.ofs$.ape$.mac$', Ext) and OptionLireMetaTags then begin
            { Lecture TAG APE }
        APETag := TAPETag.Create;
        With APETag do begin
            ReadFromFile(F);
            if (Exists) and (Trim(SeekField('Title')) <> '') then begin
                Result := RemplaceTexteTag(FormatNomTag, Duree, SeekField('Artist'), SeekField('Album'), SeekField('Track'), SeekField('Title'), Rep1, Rep0, Fichier, Ext);
                Free;
                Exit;
            end;
            Free;
        end;
    end;

        { Si le fichier est un mp3, mp2 ou mpc on tente de regarder les TAG ID3 v1.1 }
    if AnsiContainsText('$.mp3$.mp2$.mpc$', Ext) and OptionLireMetaTags then begin
            { Lecture TAG ID3 v1.1 }
        MP3Tagv1 := TID3v1.Create;
        With MP3Tagv1 do begin
            ReadFromFile(F);
            if (Exists) and (Trim(Title) <> '') then begin
                Result := RemplaceTexteTag(FormatNomTag, Duree, Artist, Album, Format('%.2d', [Track]), Title, Rep1, Rep0, Fichier, Ext);
                Free;
                Exit;
            end;
            Free;
        end;
    end;

        { Si le fichier est un wma on tente de regarder les TAG }
    if AnsiContainsText('$.wma$', Ext) and OptionLireMetaTags then begin
        WMATag := TWMAfile.Create;
        With WMATag do begin
            ReadFromFile(F);
            if (Valid) and (Trim(Title) <> '') then begin
                Result := RemplaceTexteTag(FormatNomTag, Duree, Artist, Album, Format('%.2d', [Track]), Title, Rep1, Rep0, Fichier, Ext);
                Free;
                Exit;
            end;
            Free;
        end;
    end;

        { Si le fichier est un ogg on tente de regarder les TAG }
    if AnsiContainsText('$.ogg$', Ext) and OptionLireMetaTags then begin
        OGGTag := TOggVorbis.Create;
        With OGGTag do begin
            ReadFromFile(F);
            if (Valid) and (Trim(Title) <> '') then begin
                Result := RemplaceTexteTag(FormatNomTag, Duree, Artist, Album, Format('%.2d', [Track]), Title, Rep1, Rep0, Fichier, Ext);
                Free;
                Exit;
            end;
            Free;
        end;
    end;

        { Pas de TAGs du tout ou Not(OptionLireMetaTags) }
        { Lecture du chemin du fichier }
        { On suppose que le chemin est : ARTISTE\ALBUM\CHANSON.mp3 }
    Result := RemplaceTexteSansTag(FormatNomSansTag, Rep1, Rep0, Fichier, Ext, Duree)

end;

//============================================================================//
{             Valide l'extension d'un fichier                                  }
//----------------------------------------------------------------------------//
function ValideExt(const F: string) : boolean;
var
    i : integer;
    E : string[5];
begin
    E := LowerCase(ExtractFileExt(F));
    for i := 0 to VEXT.Count - 1 do begin
        if E = '.' + VEXT[i] then begin
            Result := True;
            Exit;
        end;
    end;
    Result := False;
end;

//============================================================================//
{             Dtermine si F est une URL                                       }
//----------------------------------------------------------------------------//
function IsURL(const F: string) : boolean;
begin
    Result := (LowerCase(LeftStr(F, 7)) = 'http://') or (LowerCase(LeftStr(F, 6)) = 'mms://');
end;

//============================================================================//
{                  Mise  jours des couleurs et des icnes                     }
//----------------------------------------------------------------------------//
procedure MiseaJoursCouleurs(Totale : Boolean = True);
var
    Ini: Tinifile;
    F  : String;
begin
            { Mise  jours des couleurs et polices }
    Ini := Tinifile.Create(FichierIni);
    with Ini do begin
                { Form 1 }
      With Form1 do begin
        With TreeView1 do begin
            Color      := ReadInteger('DATA', 'BtnClFondRep',   13225925);
            Font.Color := ReadInteger('DATA', 'BtnClTexteRep',  6244901);
            Tag        := ReadInteger('DATA', 'BtnClSurvolRep', 128);
            Font.Name  := ReadString('DATA',  'PoliceName',     'Tahoma');
            Font.Size  := ReadInteger('DATA', 'PoliceSize',     8);
            Repaint;
        end;
        with Listbox1 do begin
            Color       := ReadInteger('DATA', 'BtnClFondListe',    7362860);
            Font.Color  := ReadInteger('DATA', 'BtnClTexteListe',   13225925);
            Tag         := ReadInteger('DATA', 'BtnClPlayingListe', 33023);
            Font.Name   := ReadString('DATA',  'PoliceName',        'Tahoma');
            Font.Size   := ReadInteger('DATA', 'PoliceSize',        8);
            ScrollWidth := 0;
            Repaint;
        end;
        ProgressBar1.Brush.Color := ReadInteger('DATA', 'BtnColorFondProgress', clGray);
        ProgressBar2.Brush.Color := ReadInteger('DATA', 'BtnColorFondVolume',   clGray);
        SendMessage(ProgressBar1.Handle, WM_USER + 9, 0, ReadInteger('DATA', 'BtnColorProgress', 13225925));
        SendMessage(ProgressBar2.Handle, WM_USER + 9, 0, ReadInteger('DATA', 'BtnColorVolume',   7362860));

        if Totale then begin
                { Form InfoBulle }
          With FormInfoBulle do begin
            Color             := Listbox1.Color;
            Label1.Font.Color := Listbox1.Font.Color;
            Shape1.Pen.Color  := Label1.Font.Color;
            Label1.Font.Name  := TreeView1.Font.Name;
            Label1.Font.Size  := TreeView1.Font.Size;
          end;
                { Form 2 }
          if Assigned(FormOptions) then
          With FormOptions do begin
            LabelDemoRep.Color        := TreeView1.Color;
            LabelDemoRep.Font.Color   := TreeView1.Font.Color;
            LabelDemoRep.Font.Name    := TreeView1.Font.Name;
            LabelDemoRep.Font.Size    := TreeView1.Font.Size;
            LabelDemoListe.Color      := Listbox1.Color;
            LabelDemoListe.Font.Color := Listbox1.Font.Color;
            LabelDemoListe.Font.Name  := Listbox1.Font.Name;
            LabelDemoListe.Font.Size  := Listbox1.Font.Size;
            F := ReadString('DATA', 'IconeFichiersAssocies', '');
            if FileExists(F) then
                ImageIconeFichiers.Picture.Icon.LoadFromFile(F)
            else
                ImageIconeFichiers.Picture.Icon := FormOptions.Icon;
            F := ReadString('DATA', 'Icone', '');
            if FileExists(F) then
                ImageIconeBarreDesTaches.Picture.Icon.LoadFromFile(F)
            else
                ImageIconeBarreDesTaches.Picture.Icon := FormOptions.Icon;
          end; // end with form2

                  { Icone barre des tches }
          if FileExists(ReadString('DATA', 'Icone', '')) then
              Icon.LoadFromFile(ReadString('DATA', 'Icone', ''))
          else
              Icon := FormOptions.Icon;
          With TrayIcon1 do begin
              Icon := Form1.Icon;
              BackgroundIcon := Icon;
          end;

        end; // end if Totale
      end; // end with form1
    end; // end with Ini
    Ini.Free;
end;

//============================================================================//
{                  Executer une commande                                       }
//----------------------------------------------------------------------------//
procedure Executer(const action : string);
begin
    Screen.Cursor := crHourGlass;
    ShellExecute(Form1.Handle, Nil, PChar(action), Nil, Nil, SW_SHOWNORMAL);
    Screen.Cursor := crDefault;
end;

//============================================================================//
{                  Renvoi le genre d'un chanson (ID3v1)                        }
//----------------------------------------------------------------------------//
function GetGenreFromIndex(Index : integer) : string;
begin
    if ((Index < 0) or (Index > 148)) then Index := 148;
    Result := SGenre[Index];
end;

function GetIndexofGenre(const Genre : String) : byte;
var
    i : integer;
begin
    for i := Low(SGenre) to High(SGenre) do
        if LowerCase(Genre) = LowerCase(SGenre[i]) then begin
            Result := i;
            Exit;
        end;
    Result := 148;
end;


//============================================================================//
{                  Active l'galiseur                                          }
//----------------------------------------------------------------------------//
procedure SetEqualizer;
begin
  With Form1 do
    if Channel <> 0 then begin
        fx[1] := BASS_ChannelSetFX(Form1.Channel, BASS_FX_PARAMEQ, 1);
        fx[2] := BASS_ChannelSetFX(Form1.Channel, BASS_FX_PARAMEQ, 1);
        fx[3] := BASS_ChannelSetFX(Form1.Channel, BASS_FX_PARAMEQ, 1);
        p.fBandwidth := 18;
        p.fGain := eq[1];
        p.fCenter := 125;
        BASS_FXSetParameters(fx[1], @p);
        p.fGain := eq[2];
        p.fCenter := 1000;
        BASS_FXSetParameters(fx[2], @p);
        p.fGain := eq[3];
        p.fCenter := 8000;
        BASS_FXSetParameters(fx[3], @p);
    end;
end;

//============================================================================//
{                  Defini le volume du channel                                 }
//----------------------------------------------------------------------------//
procedure SetVolume;
begin
  With Form1 do
    if OptionVolumeGlobal then begin
      BASS_SetVolume(Round(Sqr(ProgressBar2.Position / 10) + 0.4));             //on change le volume de windows
      if Channel <> 0 then
        BASS_ChannelSetAttributes(Channel, -1, 100, -101);                      //on remet le volume local a 100
    end else
      if Channel <> 0 then                                                      //on change le volume local
        BASS_ChannelSetAttributes(Channel, -1, Round(Sqr(ProgressBar2.Position / 10) + 0.4), -101);
end;

//============================================================================//
{          Vrifie si une nouvelle version est en ligne                        }
//----------------------------------------------------------------------------//
function CheckVersion(const AffSiNon : Boolean = True): Boolean;
var
    cl        : THttpCli;
    Data      : TMemoryStream;
    v, t      : string;
    IniLangue, Ini : TIniFile;
begin
    if AffSiNon then Screen.Cursor := crHourGlass;
    IniLangue := TiniFile.Create(FichierLangue);
    Data      := TMemoryStream.Create;
    cl        := THttpCli.Create(nil);
    try
        cl.URL        := 'http://dekibulle.free.fr/version.php';
        cl.RcvdStream := Data;
        Ini := Tinifile.Create(FichierIni);
        with Ini do begin
            if SectionExists('PROXY') then begin
                cl.ProxyUsername := ReadString('PROXY', 'USER', '');
                cl.ProxyPassword := ReadString('PROXY', 'PASS', '');
                cl.Proxy         := ReadString('PROXY', 'ADDRESS', '');
                cl.ProxyPort     := ReadString('PROXY', 'PORT', '');
            end;
            free;
        end;
        cl.Get;
        v := Copy(StrPas(Data.Memory), 1, Data.Size);
        Result := True;
        Form1.TimerCheckVersion.Enabled := False;

        DecimalSeparator := '.';
        if StrToFloat(v) > StrToFloat(Version) then begin
            t := IniLangue.ReadString('MESSAGES', '16', 'Nouvelle version disponible') + #13#10 + #13#10 + IniLangue.ReadString('MESSAGES', '17', 'Ouvrir le site?');
            if MessageBox(Form1.Handle, Pchar(t), 'DKiBulle', MB_ICONEXCLAMATION or MB_YESNO) = mrYes then
                Executer('http://dekibulle.free.fr');
        end else begin
            t := IniLangue.ReadString('MESSAGES', '18', 'Dernire version');
            if AffSiNon then
                MessageBox(Form1.Handle, Pchar(t), 'DKiBulle', MB_ICONQUESTION or MB_OK);
        end;
    except
        t      := IniLangue.ReadString('MESSAGES', '19', 'Erreur') + #13#10 + #13#10 + IniLangue.ReadString('MESSAGES', '17', 'Ouvrir le site?');
        Result := False;
        if AffSiNon then
            if MessageBox(Form1.Handle, Pchar(t), 'DKiBulle', MB_ICONERROR or MB_YESNO) = mrYes then
                Executer('http://dekibulle.free.fr');
    end;
    Data.Free;
    cl.Free;
    IniLangue.Free;
    Screen.Cursor := crDefault;
end;

//============================================================================//
{        Recherche les infos CDDB et les crits dans la cddb locale            }
//----------------------------------------------------------------------------//
procedure GetCDDB(Lecteur: integer);
const
    FramePerSecond = 75;
    TimeAdj        = 86400;
var
    cl           : THttpCli;
    Data         : TMemoryStream;
    Reponse, CDDBCDIDListe : TStringList;
    i            : Integer;
    t            : String;
    LocalCDDBIni, Ini : TIniFile;
    CDDBCDID     : String;
    MettreAJours : Boolean;
begin
                // Cration des variables
    MettreAJours  := False;
    Data          := TMemoryStream.Create;
    cl            := THttpCli.Create(nil);
    cl.RcvdStream := Data;
    Ini := Tinifile.Create(FichierIni);
    with Ini do begin
        if SectionExists('PROXY') then begin
            cl.ProxyUsername := ReadString('PROXY', 'USER', '');
            cl.ProxyPassword := ReadString('PROXY', 'PASS', '');
            cl.Proxy         := ReadString('PROXY', 'ADDRESS', '');
            cl.ProxyPort     := ReadString('PROXY', 'PORT', '');
        end;
        free;
    end;
    Reponse       := TStringList.Create;
    LocalCDDBIni  := TIniFile.Create(ExtractFilePath(Application.Exename) + '\DeKiBulle.cddb');
    Form1.TrayIcon1.ShowHint := True;
    Form1.TrayIcon1.ShowBalloonHint('DKiBulle','CDDB Check...', bitInfo, 10);
    try
                    // Dtermine le CDID du lecteur
        BASS_CD_GetID(Lecteur, BASS_CDID_CDDB);
        CDDBCDID := AnsiReplaceStr(BASS_CD_GetID(Lecteur, BASS_CDID_CDDB), ' ', '+');

                    // Regarde sur FreeDB.org si ce CD est rfrenc
        cl.URL := 'http://freedb.freedb.org:80/~cddb/cddb.cgi?cmd=cddb+query+' + CDDBCDID + '&hello=DeKiBulle+dekibulle.free.fr+DeKiBulle+' + Version + '&proto=5';
        cl.Get;

                    // Analyse la rponse obtenue
        t       := Copy(StrPas(Data.Memory), 1, Data.Size);
        Reponse := Split(t, ' ');
        if Reponse[0] = '200' then begin                        //200 Found exact match

                        // Le CD est rfrence, on demande les infos
            cl.URL := 'http://freedb.freedb.org:80/~cddb/cddb.cgi?cmd=cddb+read+' + Reponse[1] + '+' + Reponse[2] + '&hello=DeKiBulle+dekibulle.free.fr+DeKiBulle+' + Version + '&proto=5';
            //Executer(cl.URL);
            Data.Clear;
            cl.Get;

                        // Analyse la rponse obtenue
            Reponse.Text := Copy(StrPas(Data.Memory), 1, Data.Size);
            if AnsiStartsText('210', Reponse[0]) then begin     //210 OK, CDDB database entry follows
                With LocalCDDBIni do begin
                            // Extraction de l'artiste et de l'album
                    t := Reponse.Values['DTITLE'];
                    WriteString(CDDBCDID, 'ARTIST', LeftStr(t, Pos(' / ', t) - 1));
                    WriteString(CDDBCDID, 'ALBUM',  RightStr(t, Length(t) - Pos(' / ', t) - 2));

                            // Extraction des dures et des titres des chansons et criture dans la CDDB locale
                    CDDBCDIDListe := Split(CDDBCDID, '+');
                    For i := 0 to StrToInt(CDDBCDIDListe[1]) - 1 do begin
                        WriteString(CDDBCDID, Format('TITLE%d', [i + 1]), Reponse.Values[Format('TTITLE%d', [i])]);
                        If i < StrToInt(CDDBCDIDListe[1]) - 1 then       //La dure des piste est calcule en fonction des "Track frame offsets"
                            t := Format('[%s]', [TimeToStr((StrToInt(CDDBCDIDListe[i + 3]) - StrToInt(CDDBCDIDListe[i + 2])) / FramePerSecond / TimeAdj)])
                        else
                            t := Format('[%s]', [TimeToStr((StrToInt(CDDBCDIDListe[i + 3]) - StrToInt(CDDBCDIDListe[i + 2]) / FramePerSecond) / TimeAdj)]);
                        WriteString(CDDBCDID, Format('LENGTH%d', [i + 1]), t);
                    end;
                    CDDBCDIDListe.Free;

                            // Tout  l'air de s'tre bien droul, on met Match  True et on mettra la liste de lecture  jours
                    WriteBool(CDDBCDID, 'MATCH', True);
                    Form1.TrayIcon1.HideBalloonHint;
                    Form1.TrayIcon1.ShowHint := False;
                    MettreAJours := True;
                end; // Fin 'with LocalCDDBIni'
            end else
                LocalCDDBIni.WriteBool(CDDBCDID, 'MATCH', False);               // Il y a eu une erreur, on met Match  False
        end else begin
            LocalCDDBIni.WriteBool(CDDBCDID, 'MATCH', False);                   // Le CD n'est pas rfrenc, on met Match  False
            Form1.TrayIcon1.ShowBalloonHint('DKiBulle','CDDB Check... No match found.', bitError, 10);
        end;
    except
        Form1.TrayIcon1.ShowBalloonHint('DKiBulle','CDDB Check... Failed.', bitError, 10);
    end;

                // Libre les ressources
    cl.Free;
    Data.Free;
    Reponse.Free;
    LocalCDDBIni.Free;

                // Met  jours la liste de lecture si besoin
    if MettreAJours then
        Form1.MenuRefreshListeClick(nil);
end;

//============================================================================//
{        Extrait le nom de la chanson des ExtINF                               }
//----------------------------------------------------------------------------//
function ExtraitEXTINF(const Texte : string): string;
begin
    Result := '';
    if AnsiStartsText('#EXTINF:', Texte) and AnsiContainsStr(Texte, ',') then
        Result := Trim(RightStr(Texte, Length(Texte) - AnsiPos(',', Texte)));
end;

end.
