{
Copyright  Frdric MONTIN, 2007

dekibulle@free.fr
http://dekibulle.free.fr

**fr**

Ce logiciel est un programme informatique servant  lire des fichiers
audio sur ordinateur.

Ce fichier est une partie de dkibulle.

Dkibulle est un logiciel libre; soumis  une double licence. 
Vous pouvez le redistribuer ainsi que le modifier ds lors que vous respectez 
les termes *de l'une des deux licences*
- *soit* la licence GNU Lesser General Public License comme publie par la 
  Free Software Foundation, dans sa version 2 ou ultrieure; 
- *soit* la licence Cecill-C comme publie par Cecill,
  dans sa version 1 ou ultrieure.

**en**

This software is a computer program whose purpose is to listen audio
files on a computer.

This file is a part of Dkibulle.

Dkibulle is a free software; subjected to a double license.
You can redistribute it and/or modify since you respect the terms of either 
(at least one of the both license) :
- the GNU Lesser General Public License as published by the Free Software Foundation; 
  either version 2.1 of the License, or any later version. 
- the CeCILL-C as published by CeCILL; either version 1 of the License, or any later version.
}

unit InfoMPEG;

interface
 uses
  SysUtils, Classes;

  Type
   InfosMPEG = record
         FileSize         : Integer;
         HeaderPos        : Integer;
	 MPEGAudioversion : string;
	 Layerdescription : string;
	 Protection       : boolean;
	 Bitrate          : string;
	 Sampling         : integer;
	 Padding          : boolean;
	 ChannelMode      : string;
	 Copyright        : boolean;
	 Original         : boolean;
	 Emphasis         : string;
         Duration         : single;
  end;

  Function LireInfosMPEG(Fichier :string): InfosMPEG;
  Function TexteInfosMPEG(Fichier :string): String;

implementation

{-=-=-=-=-=-= LECTURE DES INFOS =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
Function LireInfosMPEG(Fichier :string): InfosMPEG;
var
    Fs     : TFileStream;
    Header : Array[1..4] of byte;
    b      : byte;
    Info   : InfosMPEG;
const
    BitrateV1L1 : Array[0..15] of String = ('free','32','64','96','128','160','192','224','256','288','320','352','384','416','448','bad');
    BitrateV1L2 : Array[0..15] of String = ('free','32','48','56','64','80','96','112','128','160','192','224','256','320','384','bad');
    BitrateV1L3 : Array[0..15] of String = ('free','32','40','48','56','64','80','96','112','128','160','192','224','256','320','bad');
    //BitrateV2L1 : Array[0..15] of String = ('free','32','64','96','128','160','192','224','256','288','320','352','384','416','448','bad');
    //BitrateV2L2 : Array[0..15] of String = ('free','32','48','56','64','80','96','112','128','160','192','224','256','320','384','bad');
    //BitrateV2L3 : Array[0..15] of String = ('free','8 (8)','16 (16)','24 (24)','32 (32)','64 (40)','80 (48)','56 (56)','64 (64)','128 (80)','160 (96)','112 (112)','128 (128)','256 (144)','320 (160)','bad');
    BitrateV2L1 : Array[0..15] of String = ('free','32','48','56','64','80','96','112','128','144','160','176','192','224','256','bad');
    BitrateV2L2 : Array[0..15] of String = ('free','8','16','24','32','40','48','56','64','80','96','112','128','144','160','bad');
    BitrateV2L3 : Array[0..15] of String = ('free','8','16','24','32','40','48','56','64','80','96','112','128','144','160','bad');
begin
                {  Header                             }
                { AAAAAAAA AAABBCCD EEEEFFGH IIJJKLMM }
  With Info do
  begin
            { Extraction du Header }
    Fs := TFileStream.Create(Fichier, fmOpenRead or fmShareDenyNone);
      FileSize  := Fs.Size;
      HeaderPos := 0;
      While HeaderPos = 0 do
      begin
        While b <> 255 do                // b=11111111
          Fs.read(b,1);
        Fs.read(b,1);
        if (b and 224) = 224 then        // b=111xxxxx
          HeaderPos := Fs.Position - 2;
        if Fs.Position > Fs.Size - 128 then
        begin
          Result := Info;
          Exit;
        end;
      end;
      Fs.Seek(HeaderPos, soFromBeginning);
      Fs.Read(Header, 4);
    Fs.Free;

            { B- MPEG Audio version }
    b := (Header[2] and 24);
    Case b of
        24: MPEGAudioversion := 'MPEG 1.0';
        10: MPEGAudioversion := 'MPEG 2.0';
        08: MPEGAudioversion := 'Reserved';
        00: MPEGAudioversion := 'MPEG 2.5';
    end;

            { C- Layer description }
    b := (Header[2] and 6);
    Case b of
        6: Layerdescription := 'Layer 1';
        4: Layerdescription := 'Layer 2';
        2: Layerdescription := 'Layer 3';
        0: Layerdescription := 'Reserved';
    end;

            { D- Protection }
    b := (Header[2] and 1);
    Protection := (b = 0);

            { E- Bitrate }
    b := (Header[3] and 240);
    if Trunc(b / 16) > 15 then b := 15 * 16;
    if MPEGAudioversion = 'MPEG 1.0' then
    begin
        if Layerdescription = 'Layer 1' then
          Bitrate := BitrateV1L1[Trunc(b / 16)]
        else if Layerdescription = 'Layer 2' then
          Bitrate := BitrateV1L2[Trunc(b / 16)]
        else if Layerdescription = 'Layer 3' then
          Bitrate := BitrateV1L3[Trunc(b / 16)];
    end else begin
        if Layerdescription = 'Layer 1' then
          Bitrate := BitrateV2L1[Trunc(b / 16)]
        else if Layerdescription = 'Layer 2' then
          Bitrate := BitrateV2L2[Trunc(b / 16)]
        else if Layerdescription = 'Layer 3' then
          Bitrate := BitrateV2L3[Trunc(b / 16)];
    end;

            { F- Sampling rate frequency }
    b := (Header[3] and 12);
    if MPEGAudioversion = 'MPEG 1.0' then
    begin
        case b of
            8: Sampling := 32000;
            4: Sampling := 48000;
            0: Sampling := 44100;
        end;
    end else if MPEGAudioversion = 'MPEG 2.0' then
    begin
        case b of
            8: Sampling := 16000;
            4: Sampling := 24000;
            0: Sampling := 22050;
        end;
    end else if MPEGAudioversion = 'MPEG 2.5' then
    begin
        case b of
            8: Sampling := 8000;
            4: Sampling := 12000;
            0: Sampling := 11025;
        end;
    end;

            { Duration (estimation in s) }
    try
      Duration := FileSize * 8 / StrToInt(Bitrate) / 1000;
    except
      Duration := 0;
    end;

            { G- Padding }
    b := (Header[3] and 2);
    Padding := (b = 0);

            { I- Channel Mode }
    b := (Header[4] and 192);
    case b of
        192: ChannelMode := 'Single channel (Mono)';
        128: ChannelMode := 'Dual channel (Stereo)';
        064: ChannelMode := 'Joint stereo (Stereo)';
        000: ChannelMode := 'Stereo';
    end;

            { K- Copyright }
    b := (Header[4] and 8);
    Copyright := (b = 8);

            { L- Original }
    b := (Header[4] and 4);
    Original := (b = 4);

            { M- Emphasis }
    b := (Header[4] and 3);
    case b of
        3: Emphasis := 'CCIT J.17';
        2: Emphasis := 'Reserved';
        1: Emphasis := '50/15 ms';
        0: Emphasis := 'None';
    end;

  end;

  Result := Info;

end;

{-=-=-=-=-=-= LECTURE DES INFOS PUIS REPORT SOUS FORMAT TEXTE =-=-=-=-=-=-=-=-=-=-=-}
Function TexteInfosMPEG(Fichier :string): String;
var
    I : InfosMPEG;
    t : TStringList;
begin
    I := LireInfosMPEG(Fichier);
    t := TStringList.Create;
    with I do begin
      with t do begin
          Add(Format('Size : %d bytes', [FileSize]));
          Add(Format('Header found at : %d bytes', [HeaderPos]));
          Add(Format('%s %s', [MPEGAudioversion,Layerdescription]));
          Add(Format('%s Kbit/s, %d Hz, %s', [Bitrate, Sampling, ChannelMode]));
          Add(Format('Duration : %fs (%s)', [Duration, TimeToStr(Duration / 86400)]));
          If Protection then
            Add('Protected : Yes')
          else
            Add('Protected : No');
          if Copyright then
            Add('Copyrighted : Yes')
          else
            Add('Copyrighted : No');
          if Original then
            Add('Original : Yes')
          else
            Add('Original : No');
          Add(Format('Emphasis : %s', [Emphasis]));
          Result := Text;
          Free;
      end;
    end;
end;



end.
